require('acme')
require('node')

function main()
   local E = acme.getEvents(acme.lastCheckTime())
   
   for i=1,#E.EventList do
     ProcessEvent(E.EventList[i])
   end
   acme.updateLastCheckTime()
end

function ProcessEvent(E)
   local Handler = 
       EventTable[E:nodeName()]
   debug(Handler)
   if Handler then
      Handler(E)   
   end
end

function GenerateA04(E)
   PushEvent('AO4:'..E.id)
end

function GenerateA08(E)
   PushEvent('A08:'..E.id)
end

function LabOrder(E)
   -- Ignore for this site   
end


function PushEvent(Q)
   queue.push{data=Q}     
end

EventTable={
   PersonUpdate=GenerateA04,
   PersonDischarge=GenerateA08,
   LabOrder=LabOrder,
}


function debug(X) return end
